﻿namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    private static void Main()
    {
        List<Item> sourceList = new List<Item>
        {
            new Item { ID = 1, Name = "Nima", Year = 1990, Data = 10 },
            new Item { ID = 2, Name = "Nima", Year = 1990, Data = 11 },
            new Item { ID = 3, Name = "Nima", Year = 2000, Data = 12 },
            new Item { ID = 4, Name = "John", Year = 2001, Data = 1  },
            new Item { ID = 5, Name = "John", Year = 2002, Data = 2  },
            new Item { ID = 6, Name = "Sara", Year = 2010, Data = 4  }
        };

        Console.WriteLine("소스 리스트");
        Console.WriteLine("----------------------------------------");

        foreach(Item item in sourceList)
        {
            Console.WriteLine(item);
        }

        Console.WriteLine("----------------------------------------");
        Console.WriteLine();
        Console.WriteLine("결과 리스트");
        Console.WriteLine("----------------------------------------");

        IEnumerable<Item> resultEnumerable = sourceList.GroupBy(x => x.Name)
                                                       .Select
                                                        (
                                                            groups => new Item
                                                            {
                                                                Name = groups.First().Name,
                                                                Year = groups.First().Year,
                                                                Data = groups.First().Data
                                                            }
                                                        );

        foreach(var item in resultEnumerable)
        {
            Console.WriteLine(item);
        }

        Console.WriteLine("----------------------------------------");
    }

    #endregion
}